# Ensys srl
# 
# Questo esempio recupera il dato della temperatura dal sensore installato nella IndRsp
# 
# Verificare di aver abilitato la porta I2C0, ad esempio integrando nel file
# 	/boot/config.txt 
# le seguenti righe:
# 	#i2c0 - periferiche
# 	dtparam=i2c0=on
# 	dtoverlay=i2c0-bcm2708,pins_28_29
#  
# Per eseguire questo script utilizzare il comando:
# 	python3 mcp9808t.py

import smbus
import time
import struct

i2c0 = smbus.SMBus(0)

HD__DEV__ADDR = 0x1F
HD__ID__ADDR = 0x06
HD__ID__VAL = 0x0054

def i2c__byte_read_byte(add):
    i2c0.write_byte(HD__DEV__ADDR, add)
    number = i2c0.read_byte(HD__DEV__ADDR)
    return number

def i2c__byte_read_word(add):
    data_byte = i2c0.read_i2c_block_data(HD__DEV__ADDR, add, 2)
    data_word = data_byte[0]<<8
    data_word |= data_byte[1]
    return data_word

def i2c__byte_write_byte(add, val):
    i2c0.write_byte(HD__DEV__ADDR, add)
    i2c0.write_byte(HD__DEV__ADDR, val)
    return
    
while True:
	# Set resolution
	id_chip = i2c__byte_read_word(HD__ID__ADDR)
	if(id_chip==HD__ID__VAL):
		print("OK, trovato MCP9808T!\n")
		
		while(1):
			# Lettura temperatura
			i2c__byte_write_byte(0x08, 3)
			data = i2c__byte_read_word(0x05)

			# Trasformazione in °C
			if(data!=0xFFFF):
				temp = data & 0x0FFF
				temp /= 16.0
				if (data & 0x1000):
					temp = 256 - temp

			print(temp)
		
	else:
	    print(id_chip)

		
	time.sleep(1)

#End of the Script
